#ifndef TOOL_H_
#define TOOL_H_

#include <string>
#include <msp/core/application.h>
#include <msp/datafile/writer.h>

class DataTool: public Msp::RegisteredApplication<DataTool>
{
private:
	std::list<std::string> in_fns;
	std::string out_fn;
	bool binary;
	bool compile;
	unsigned float_size;
	bool compress;
	bool pack;
	bool unpack;
	bool debug;

public:
	DataTool(int argc, char **argv);

	virtual int main();
private:
	void do_transfer();
	void do_compile();
	void do_pack();
	void do_unpack();
	Msp::IO::Base *open_output(const std::string &);
	Msp::IO::Base *open_input(const std::string &);
public:
	Msp::DataFile::Writer *create_writer(Msp::IO::Base &);
};

#endif
